<template>
  <div>
    <el-dialog title="批量修改服务门店" custom-class="customer-dailog" :visible.sync="dialogVisible"
      :close-on-click-modal="false" @close="cancel" width="600px">
      <div class="checkedCustomers">当前选中<span class="num"> {{ multipleList.length }} </span>位客户
      </div>
      <el-form ref="form" :model="form" :rules="rules" label-width="133px">
        <el-form-item label="服务门店：" prop="mainStoreId">
          <el-select style="width: 382px" v-model="form.mainStoreId" filterable remote
            reserve-keyword placeholder="请输入门店名称/门店code" :remote-method="getMainStoreCodeName"
            :loading="loading">
            <el-option v-for="item in mainstoreList" :key="item.storeId" :label="item.storeName"
              :value="item.storeId" />
          </el-select>
        </el-form-item>
        <el-form-item label="原因备注：" prop="remark">
          <el-input type="text" maxlength="20" show-word-limit v-model="form.remark"
            style="width: 382px;"></el-input>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" :loading="btnLoading" @click="submit">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import { doFetch, doFetchqs } from "../../axios/api";
import url from "../../axios/url";
import { mapState } from "vuex";
import { checkFalse, checkStatus, checkSuccess } from "../../../../static/js/checkStatus";
export default {
  name: "mainstoreDailog",
  props: {
    dialogVisible: {
      type: Boolean,
      default: false
    },
    multipleList: {
      type: Array,
      default: () => {
        return [];
      }
    },
    gradeList: {
      type: Array,
      default: () => {
        return [];
      }
    },
    pageSize: {
      type: Number,
      default: ''
    },
    memberSearchStr: {
      type: Number,
      default: ''
    },
    phoneNameCard: {
      type: String,
      default: ''
    },
    pageName: {
      type: String,
      default: ''
    },
  },
  data() {
    return {
      form: {
        remark: "",
        optType: 1, // 1服务门店（主门店），2协管门店
        mainOptType: 4, //服务门店类型 1替换为最新协管的门店 2替换为最新协管的自营门店 3 替换为最新协管的自营/联营门店 4自定义主门店 
        mainStoreId: ""
      },
      rules: {
        mainStoreId: [
          { required: true, message: "请选择服务门店", trigger: "change" }
        ],
        remark: [
          { required: true, message: "请输入原因备注", trigger: "change" }
        ]
      },
      mainstoreList: [],
      loading: false,
      btnLoading: false,
    };
  },
  computed: {
    ...mapState([ "showEditClique" ])
  },
  methods: {
    cancel() {
      this.$refs[ 'form' ].resetFields();
      this.$emit('update:dialogVisible', false);
    },
    getMainStoreCodeName(val) {
      this.loading = true;
      doFetchqs(url.storeCodeName, {
        searchParam: val,
        flag: 1
      })
        .then(res => {
          if (res.data.errorCode === 0) {
            this.mainstoreList = res.data.result;
          } else {
            checkFalse(res.data.message);
          }
        })
        .catch(err => {
          checkStatus(err);
        }).finally(_ => this.loading = false);
    },
    submit() {
      this.$refs[ 'form' ].validate(valid => {
        if (valid) {
          this.btnLoading = true;
          let memberIdsArr = [];
          this.multipleList.forEach(item => {
            memberIdsArr.push(item.memberId);
          });
          doFetch(url.updateStore, Object.assign({}, this.form, {
            memberIds: this.selectAll == true ? "-1" : memberIdsArr.join(","),
            isCurrent: this.selectAll == true ? 2 : this.multipleList.length == this.pageSize ? 1 : 0,
            memberSearchParamStr: this.selectAll == true ? (this.memberSearchStr ? this.memberSearchStr : "-1") : "",
            phoneNameCard: this.phoneNameCard,
            pageName: this.pageName
          }))
            .then(res => {
              if (res.data.errorCode === 0) {
                setTimeout(() => {
                  this.btnLoading = false;
                  checkSuccess();
                  this.$refs[ 'form' ].resetFields();
                  this.$emit('update:dialogVisible', false);
                  this.$emit('refresh');
                }, 4500);
              } else {
                checkFalse();
                this.btnLoading = false;
              }
            })
            .catch(err => {
              this.btnLoading = false;
              checkStatus(err);
            });
        } else {
          return false;
        }
      });
    },
  }
};

</script>
<style lang="less" scoped>
.customer-dailog {
  .checkedCustomers {
    margin-left: 133px;
    margin-bottom: 20px;
    font-size: 14px;
    font-weight: 400;
    color: #909399;
    line-height: 20px;
    .num {
      color: #303133;
    }
  }
  .sub-tip {
    margin: 4px 0 -5px;
    font-size: 12px;
    font-weight: 400;
    color: #909399;
    line-height: 17px;
  }
}
</style>
